using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Drawing2D;

using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;

namespace SymbolFactory
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView paletteGroupView1;
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram1;		
		private System.Windows.Forms.ComboBox cbOuterShape;
		private System.Windows.Forms.ComboBox cbInnerShape;
		private System.Windows.Forms.Button btnSymbolModel;
		private System.Windows.Forms.Splitter splitter1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// Set the initial outer and inner shapes in the ComboBoxes and generate a SymbolModel using the selected shapes
			this.cbOuterShape.SelectedIndex = 0;
			this.cbInnerShape.SelectedIndex = 2;
			this.GenerateSymbolModelForShapes();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.panel1 = new System.Windows.Forms.Panel();
			this.cbInnerShape = new System.Windows.Forms.ComboBox();
			this.cbOuterShape = new System.Windows.Forms.ComboBox();
			this.btnSymbolModel = new System.Windows.Forms.Button();
			this.paletteGroupView1 = new Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView();
			this.diagram1 = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).BeginInit();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(96, 32);
			this.label1.TabIndex = 1;
			this.label1.Text = "Select an Outer Shape";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(96, 32);
			this.label2.TabIndex = 2;
			this.label2.Text = "Select an Inner Shape";
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.cbInnerShape);
			this.panel1.Controls.Add(this.cbOuterShape);
			this.panel1.Controls.Add(this.label1);
			this.panel1.Controls.Add(this.label2);
			this.panel1.Controls.Add(this.btnSymbolModel);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(112, 438);
			this.panel1.TabIndex = 4;
			// 
			// cbInnerShape
			// 
			this.cbInnerShape.Items.AddRange(new object[] {
															  "Rectangle",
															  "RoundRect",
															  "Ellipse"});
			this.cbInnerShape.Location = new System.Drawing.Point(8, 144);
			this.cbInnerShape.Name = "cbInnerShape";
			this.cbInnerShape.Size = new System.Drawing.Size(96, 21);
			this.cbInnerShape.TabIndex = 9;
			this.cbInnerShape.Text = "Ellipse";
			// 
			// cbOuterShape
			// 
			this.cbOuterShape.Items.AddRange(new object[] {
															  "Rectangle",
															  "RoundRect",
															  "Ellipse"});
			this.cbOuterShape.Location = new System.Drawing.Point(8, 56);
			this.cbOuterShape.Name = "cbOuterShape";
			this.cbOuterShape.Size = new System.Drawing.Size(96, 21);
			this.cbOuterShape.TabIndex = 8;
			this.cbOuterShape.Text = "Rectangle";
			// 
			// btnSymbolModel
			// 
			this.btnSymbolModel.Location = new System.Drawing.Point(8, 184);
			this.btnSymbolModel.Name = "btnSymbolModel";
			this.btnSymbolModel.Size = new System.Drawing.Size(88, 23);
			this.btnSymbolModel.TabIndex = 7;
			this.btnSymbolModel.Text = "Symbol Model";
			this.btnSymbolModel.Click += new System.EventHandler(this.btnSymbolModel_Click);
			// 
			// paletteGroupView1
			// 
			this.paletteGroupView1.Dock = System.Windows.Forms.DockStyle.Left;
			this.paletteGroupView1.EditMode = false;
			this.paletteGroupView1.Location = new System.Drawing.Point(112, 0);
			this.paletteGroupView1.Name = "paletteGroupView1";
			this.paletteGroupView1.Palette = null;
			this.paletteGroupView1.Size = new System.Drawing.Size(152, 438);
			this.paletteGroupView1.TabIndex = 5;
			this.paletteGroupView1.Text = "paletteGroupView1";
			// 
			// diagram1
			// 
			this.diagram1.AllowDrop = true;
			// 
			// diagram1.Controller
			// 
			this.diagram1.Controller.MaxHistory = 256;
			this.diagram1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram1.HScroll = true;
			this.diagram1.LayoutManager = null;
			this.diagram1.Location = new System.Drawing.Point(264, 0);
			// 
			// diagram1.Model
			// 
			this.diagram1.Model.HeaderFooterData.Footer.Bounds.Width = 650F;
			this.diagram1.Model.HeaderFooterData.Header.Bounds.Width = 650F;
			this.diagram1.Model.Height = 1056F;
			this.diagram1.Model.Name = "Model";
			this.diagram1.Model.Width = 816F;
			this.diagram1.Name = "diagram1";
			this.diagram1.Size = new System.Drawing.Size(552, 438);
			this.diagram1.SmartSizeBox = false;
			this.diagram1.TabIndex = 6;
			this.diagram1.Text = "diagram1";
			this.diagram1.VScroll = true;
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(264, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 438);
			this.splitter1.TabIndex = 7;
			this.splitter1.TabStop = false;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(816, 438);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.diagram1);
			this.Controls.Add(this.paletteGroupView1);
			this.Controls.Add(this.panel1);
			this.Name = "Form1";
			this.Text = "Symbol Factory";
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnSymbolModel_Click(object sender, System.EventArgs e)
		{
			this.GenerateSymbolModelForShapes();				
		}
	
		private void GenerateSymbolModelForShapes()
		{
			SymbolModel mysymbolmdl = new SymbolModel();

			// Create and add the outer and inner shape nodes that will make up the Symbol
			Syncfusion.Windows.Forms.Diagram.FilledShape outershape = null;
			switch(this.cbOuterShape.SelectedIndex)
			{
				case 0:
					outershape = new Syncfusion.Windows.Forms.Diagram.Rectangle(0, 0, 120, 80);
					outershape.FillStyle.Type = FillStyleType.Hatch;
					outershape.FillStyle.HatchBrushStyle = HatchStyle.Wave;
					outershape.Name = "Rectangle";
					break;
				case 1:
					outershape = new Syncfusion.Windows.Forms.Diagram.RoundRect(0, 0, 120, 80);
					outershape.FillStyle.Type = FillStyleType.Hatch;
					outershape.FillStyle.HatchBrushStyle = HatchStyle.OutlinedDiamond;
					outershape.Name = "RoundRect";
					break;
				default:
					outershape = new Syncfusion.Windows.Forms.Diagram.Ellipse(0, 0, 120, 80);
					outershape.FillStyle.Type = FillStyleType.Hatch;
					outershape.FillStyle.HatchBrushStyle = HatchStyle.WideDownwardDiagonal;
					outershape.Name = "Ellipse";
					break;
			}			
			
			outershape.FillStyle.ForeColor = Color.DarkBlue;
			outershape.FillStyle.Color = Color.LightSkyBlue;
			outershape.ShadowStyle.Visible = true;
			mysymbolmdl.AppendChild(outershape);

			// Depending on the combo selection create the inner child node
			Syncfusion.Windows.Forms.Diagram.FilledShape innershape = null;
			switch(this.cbInnerShape.SelectedIndex)
			{
				case 0:
					innershape = new Syncfusion.Windows.Forms.Diagram.Rectangle(10, 10, 100, 60);
					innershape.FillStyle.ForeColor = System.Drawing.Color.Orange;
					innershape.Name = "Rectangle";
					break;
				case 1:
					innershape = new Syncfusion.Windows.Forms.Diagram.RoundRect(10, 10, 100, 60);
					innershape.FillStyle.ForeColor = System.Drawing.Color.Violet;
					innershape.Name = "RoundRect";
					break;
				default:
					innershape = new Syncfusion.Windows.Forms.Diagram.Ellipse(10, 10, 100, 60);
					innershape.FillStyle.ForeColor = System.Drawing.Color.MintCream;
					innershape.Name = "Ellipse";
					break;
			}
			innershape.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.LinearGradient;
			innershape.FillStyle.Color = Color.Bisque;
			mysymbolmdl.AppendChild(innershape);

			// Add a Label for the Symbol
			SymbolLabel lbl = new SymbolLabel();
			lbl.Text = "Hello World";
			lbl.Anchor = BoxPosition.Center;
			lbl.BackgroundStyle.Color = Color.Transparent;
			lbl.ReadOnly = true;
			mysymbolmdl.Labels.Add(lbl);

			mysymbolmdl.AutoHidePorts = true;
			mysymbolmdl.CenterPortEnabled = true;
			mysymbolmdl.Name = String.Concat(outershape.Name, "-", innershape.Name);
			
			mysymbolmdl.SmallIcon = new Bitmap("..\\..\\res\\symbol_small.bmp");
			mysymbolmdl.LargeIcon = new Bitmap("..\\..\\res\\symbol_large.bmp");

			// Set up the PaletteGroupView control with a SymbolPalette and add an entry for the new SymbolModel
			this.paletteGroupView1.Palette = new SymbolPalette();
			
			int imageIdx = 0;
			int lgImageIdx = 0;
			int smImageIdx = 0;
			if (mysymbolmdl.SmallIcon != null)
				smImageIdx = this.paletteGroupView1.AddSmallIcon(mysymbolmdl.SmallIcon);
			if (mysymbolmdl.LargeIcon != null)
				lgImageIdx = this.paletteGroupView1.AddLargeIcon(mysymbolmdl.LargeIcon);

			if(this.paletteGroupView1.SmallImageView)
				imageIdx = smImageIdx;
			else
				imageIdx = lgImageIdx;

			// Create a PaletteGroupView item to represent the SymbolModel and add it to the PaletteGroupView
			Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView.GroupViewPaletteItem gvItem = 
				new PaletteGroupView.GroupViewPaletteItem(mysymbolmdl, imageIdx);
			this.paletteGroupView1.GroupViewItems.Add(gvItem);	
		}
	}
}
